<?php
namespace Teknisa\PLA\Modules\Cardapio\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\Report\ReportService;

class Pla05900AssistenteCardapioReport extends \Zeedhi\Framework\Controller\Report {

    protected $environment;
    protected $birtStrategy;
    protected $entityManager;
    
    protected $reportMapping = array (
        'pla05900' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => array (
                'NRLOGINTCARD' => 'P_NRLOGINTCARD',
                'NRORG' => 'P_NRORG'
            ),
        )
    );
    
    public function __construct($reportService, $entityManager, $environment, $birtStrategy) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->birtStrategy = $birtStrategy;
        $this->reportService = $reportService;
    }

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $row['NRLOGINTCARD']=$row[0];
        $row['NRORG']=$row[1];
        $row['QR2TYPE']='pdf';
        $row['__report_name']='pla05900';
        $this->birtStrategy->setReportFormat($row['QR2TYPE']);
    }
	

}

