<?php
namespace Teknisa\PLA\Modules\Parametros\Services;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response\Error;
use Teknisa\GER\Services\CrudService;
use Doctrine\DBAL\Connection;
use Exception;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Pla01900ParametroDePlanejamentoService extends \Teknisa\GER\Controllers\TeknisaCrud{
    
    protected $connection;
    protected $crudservice;
    protected $parameterbag;
    
    public function __construct($crudservice, $parameterbag, $entityManager){
        $this->crudservice   = $crudservice;
        $this->parameterbag  = $parameterbag;
        $this->entityManager = $entityManager;
        $this->connection    = $entityManager->getConnection();
        
        parent::__construct($crudservice, $parameterbag);
    }
    
    public function exportParamUnidade($request, $response, $nrlista, $filialOrigem, $data){
        self::verifyExistParamPlanejaExport($nrlista);
        $rowParamPlaneja = self::getParamsParamPlaneja($filialOrigem);
        $rowParamFilial = self::getParamsParamFilial($filialOrigem);
        $rowUnidMediFili = self::getParamsUnidMediFili($filialOrigem);
        $allCdFilial = $data['ALLCDFILIAL'];
        
        if($data['PLANEJAMENTO'] === 'S'){
            self::exportPlanejamento($request, $response, $nrlista, $rowParamPlaneja, $rowParamFilial, $allCdFilial);
        }
        
        if($data['SAFRACARD'] === 'S'){
            self::exportSafraCard($request, $response, $nrlista, $rowParamPlaneja, $allCdFilial);
        }
        
        if($data['EFETIVOS'] === 'S'){
            self::exportEfetivos($request, $response, $nrlista, $rowParamPlaneja, $allCdFilial);
        }
        
        if($data['MENSCARDIARIO'] === 'S'){
            self::exportMensCardDia($request, $response, $nrlista, $rowParamPlaneja, $allCdFilial);
        }
    
        if($data['MENSCARSEMANAL'] === 'S'){
            self::exportMensCardSem($request, $response, $nrlista, $rowParamPlaneja, $allCdFilial);
        }
        
        if($data['MENSCARMENSAL'] === 'S'){
            self::exportMensCardMens($request, $response, $nrlista, $rowParamPlaneja, $allCdFilial);
        }
        
        if($data['REQRETPRATO'] === 'S'){
            self::exportReqRetPrato($request, $response, $nrlista, $rowParamPlaneja, $allCdFilial);
        }
        
        if($data['CONFIGPRATO'] === 'S'){
            self::exportConfigPrato($request, $response, $nrlista, $rowParamPlaneja, $allCdFilial);
        }
        if($data['DADOSTRANSPORTE'] === 'S'){
            self::exportDadosTransporte($request, $response, $nrlista, $rowParamPlaneja, $rowUnidMediFili, $allCdFilial);
        }
        
        if($data['CALCCONSPLA'] === 'S'){
            self::exportCalcConsPla($request, $response, $nrlista, $filialOrigem, $allCdFilial, $rowParamFilial);
        }
        
        if($data['ELABCARD'] === 'S'){
            self::exportElabCard($request, $response, $nrlista, $rowParamPlaneja, $allCdFilial);
        }
        
        if($data['PRODDIST'] === 'S'){
            self::exportProdDist($request, $response, $nrlista, $rowParamPlaneja, $allCdFilial);
        }
    }
    
    public function exportPlanejamento($request, $response, $nrlista, $rowParamPlaneja, $rowParamFilial, $allCdFilial){
        $sql = "UPDATE PARAMPLANEJA SET CDNUTRRELAT1 = :CDNUTRRELAT1, CDNUTRRELAT2 = :CDNUTRRELAT2, CDNUTRRELAT3 = :CDNUTRRELAT3, CDNUTRRELAT4 = :CDNUTRRELAT4, IDBLPRCUSZER = :IDBLPRCUSZER, IDCARDIAUTIL = :IDCARDIAUTIL, IDCUSPADCAR = :IDCUSPADCAR, IDRESTRCARD = :IDRESTRCARD, IDRESTRAPROVCARD = :IDRESTRAPROVCARD, IDACOMPCUSTO = :IDACOMPCUSTO, IDCONSGRPRAT = :IDCONSGRPRAT, IDSOMACOMEST = :IDSOMACOMEST, IDCALPADCMP = :IDCALPADCMP, IDCARDIFRETI = :IDCARDIFRETI, VRINDCALCMP = :VRINDCALCMP, CDTPRETIPADR = :CDTPRETIPADR, CDTPCUSTCMP = :CDTPCUSTCMP, IDPRINVENRETI = :IDPRINVENRETI, IDBLOQNECCOMP = :IDBLOQNECCOMP, IDSERVINCFILAGR = :IDSERVINCFILAGR, IDENVMAILCARD = :IDENVMAILCARD, IDUTLVALCARD = :IDUTLVALCARD, IDBLOQREQVALCARD = :IDBLOQREQVALCARD, IDBLOQLIBCAVALCARD = :IDBLOQLIBCAVALCARD, IDBLOQAPRCAVALCARD = :IDBLOQAPRCAVALCARD, IDBLOQAPMATVALCARD = :IDBLOQAPMATVALCARD, IDBLOQPREVCONVALCARD = :IDBLOQPREVCONVALCARD WHERE CDPARPLANEJA = '1' AND (EXISTS (SELECT 1 FROM LISTA WHERE NRLISTA = :NRLISTA AND PARAMPLANEJA.CDFILIAL = CDLISTA) OR :ALLCDFILIAL = 'T')";
        
         $params = array(
            "CDNUTRRELAT1"          => $rowParamPlaneja[0]['CDNUTRRELAT1'],
            "CDNUTRRELAT2"          => $rowParamPlaneja[0]['CDNUTRRELAT2'],
            "CDNUTRRELAT3"          => $rowParamPlaneja[0]['CDNUTRRELAT3'],
            "CDNUTRRELAT4"          => $rowParamPlaneja[0]['CDNUTRRELAT4'],
            "IDBLPRCUSZER"          => $rowParamPlaneja[0]['IDBLPRCUSZER'],
            "IDCARDIAUTIL"          => $rowParamPlaneja[0]['IDCARDIAUTIL'],
            "IDCUSPADCAR"           => $rowParamPlaneja[0]['IDCUSPADCAR'],
            "IDRESTRCARD"           => $rowParamPlaneja[0]['IDRESTRCARD'],
            "IDRESTRAPROVCARD"      => $rowParamPlaneja[0]['IDRESTRAPROVCARD'],
            "IDACOMPCUSTO"          => $rowParamPlaneja[0]['IDACOMPCUSTO'],
            "IDCONSGRPRAT"          => $rowParamPlaneja[0]['IDCONSGRPRAT'],
            "IDSOMACOMEST"          => $rowParamPlaneja[0]['IDSOMACOMEST'],
            "IDCALPADCMP"           => $rowParamPlaneja[0]['IDCALPADCMP'],
            "IDCARDIFRETI"          => $rowParamPlaneja[0]['IDCARDIFRETI'],
            "VRINDCALCMP"           => $rowParamPlaneja[0]['VRINDCALCMP'],
            "CDTPRETIPADR"          => $rowParamPlaneja[0]['CDTPRETIPADR'],
            "CDTPCUSTCMP"           => $rowParamPlaneja[0]['CDTPCUSTCMP'],
            "IDPRINVENRETI"         => $rowParamPlaneja[0]['IDPRINVENRETI'],
            "IDBLOQNECCOMP"         => $rowParamPlaneja[0]['IDBLOQNECCOMP'],
            "IDSERVINCFILAGR"       => $rowParamPlaneja[0]['IDSERVINCFILAGR'],
            "IDENVMAILCARD"         => $rowParamPlaneja[0]['IDENVMAILCARD'],
            "IDUTLVALCARD"          => $rowParamPlaneja[0]['IDUTLVALCARD'],
            "IDBLOQREQVALCARD"      => $rowParamPlaneja[0]['IDBLOQREQVALCARD'],
            "IDBLOQLIBCAVALCARD"    => $rowParamPlaneja[0]['IDBLOQLIBCAVALCARD'],
            "IDBLOQAPRCAVALCARD"    => $rowParamPlaneja[0]['IDBLOQAPRCAVALCARD'],
            "IDBLOQAPMATVALCARD"    => $rowParamPlaneja[0]['IDBLOQAPMATVALCARD'],
            "IDBLOQPREVCONVALCARD"  => $rowParamPlaneja[0]['IDBLOQPREVCONVALCARD'],
            "ALLCDFILIAL"           => $allCdFilial,
            "NRLISTA"               => $nrlista
        );
        
        self::executeQuery($sql, $params);
    }
    
    public function exportSafraCard($request, $response, $nrlista, $rowParamPlaneja, $allCdFilial){
        $sql = "UPDATE PARAMPLANEJA SET IDCONSPROD = :IDCONSPROD, IDPERCCOME = :IDPERCCOME, NRCORSAFRA = :NRCORSAFRA, NRCORINICSAF = :NRCORINICSAF, NRCORENTRSAF = :NRCORENTRSAF, NRCORNUTIL = :NRCORNUTIL, NRCORNALTE = :NRCORNALTE, NRCORCARDESP = :NRCORCARDESP, NRCORCARDREV = :NRCORCARDREV, IDALTCOMCARD = :IDALTCOMCARD, VRPEMAXDIFPLAPA = :VRPEMAXDIFPLAPA, VRPEMINDIFPLAPA = :VRPEMINDIFPLAPA, CDTIPOCUSTODESC = :CDTIPOCUSTODESC, IDBLQFECHCARD = :IDBLQFECHCARD WHERE CDPARPLANEJA = '1' AND (EXISTS (SELECT 1 FROM LISTA WHERE NRLISTA = :NRLISTA AND PARAMPLANEJA.CDFILIAL = CDLISTA) OR :ALLCDFILIAL = 'T')";
        
        $params = array(
            "IDCONSPROD"        => $rowParamPlaneja[0]['IDCONSPROD'],
            "IDPERCCOME"        => $rowParamPlaneja[0]['IDPERCCOME'],
            "NRCORSAFRA"        => $rowParamPlaneja[0]['NRCORSAFRA'],
            "NRCORINICSAF"      => $rowParamPlaneja[0]['NRCORINICSAF'],
            "NRCORENTRSAF"      => $rowParamPlaneja[0]['NRCORENTRSAF'],
            "NRCORNUTIL"        => $rowParamPlaneja[0]['NRCORNUTIL'],
            "NRCORNALTE"        => $rowParamPlaneja[0]['NRCORNALTE'],
            "NRCORCARDESP"      => $rowParamPlaneja[0]['NRCORCARDESP'],
            "NRCORCARDREV"      => $rowParamPlaneja[0]['NRCORCARDREV'],
            "IDALTCOMCARD"      => $rowParamPlaneja[0]['IDALTCOMCARD'],
            "VRPEMAXDIFPLAPA"   => $rowParamPlaneja[0]['VRPEMAXDIFPLAPA'],
            "VRPEMINDIFPLAPA"   => $rowParamPlaneja[0]['VRPEMINDIFPLAPA'],
            "CDTIPOCUSTODESC"   => $rowParamPlaneja[0]['CDTIPOCUSTODESC'],
            "IDBLQFECHCARD"     => $rowParamPlaneja[0]['IDBLQFECHCARD'],
            "ALLCDFILIAL"       => $allCdFilial,
            "NRLISTA"           => $nrlista
        );
        self::executeQuery($sql, $params);
    }
    
    public function exportEfetivos($request, $response, $nrlista, $rowParamPlaneja, $allCdFilial){
        $sql = "UPDATE PARAMPLANEJA SET TXLAYOUTCATR = :TXLAYOUTCATR, IDEFETCARDIA = :IDEFETCARDIA, IDPEREFEPOSDTPR = :IDPEREFEPOSDTPR, IDPERLEFESRETPLA = :IDPERLEFESRETPLA, IDBLQEFEDIAFECH = :IDBLQEFEDIAFECH, NRDIAANTDTPROC = :NRDIAANTDTPROC, IDPEREFETFATMPLA = :IDPEREFETFATMPLA WHERE CDPARPLANEJA = '1' AND (EXISTS (SELECT 1 FROM LISTA WHERE NRLISTA = :NRLISTA AND PARAMPLANEJA.CDFILIAL = CDLISTA) OR :ALLCDFILIAL = 'T')";
        
        $params = array(
            "TXLAYOUTCATR"      => $rowParamPlaneja[0]['TXLAYOUTCATR'],
            "IDEFETCARDIA"      => $rowParamPlaneja[0]['IDEFETCARDIA'],
            "IDPEREFEPOSDTPR"   => $rowParamPlaneja[0]['IDPEREFEPOSDTPR'],
            "IDPERLEFESRETPLA"  => $rowParamPlaneja[0]['IDPERLEFESRETPLA'],
            "IDBLQEFEDIAFECH"   => $rowParamPlaneja[0]['IDBLQEFEDIAFECH'],
            "NRDIAANTDTPROC"    => $rowParamPlaneja[0]['NRDIAANTDTPROC'],
            "IDPEREFETFATMPLA"  => $rowParamPlaneja[0]['IDPEREFETFATMPLA'],
            "ALLCDFILIAL"       => $allCdFilial,
            "NRLISTA"           => $nrlista
        );
        self::executeQuery($sql, $params);
    }
    
    public function exportMensCardDia($request, $response, $nrlista, $rowParamPlaneja, $allCdFilial){
        $sql = "UPDATE PARAMPLANEJA SET TXMENSCARDIA = :TXMENSCARDIA WHERE CDPARPLANEJA = '1' AND (EXISTS (SELECT 1 FROM LISTA WHERE NRLISTA = :NRLISTA AND PARAMPLANEJA.CDFILIAL = CDLISTA) OR :ALLCDFILIAL = 'T')";

        $params = array(
            "TXMENSCARDIA"  => $rowParamPlaneja[0]['TXMENSCARDIA'],
            "ALLCDFILIAL"   => $allCdFilial,
            "NRLISTA"       => $nrlista
        );
        self::executeQuery($sql, $params);
    }
    
    public function exportMensCardSem($request, $response, $nrlista, $rowParamPlaneja, $allCdFilial){
        $sql = "UPDATE PARAMPLANEJA SET TXMENSCARSEM = :TXMENSCARSEM WHERE CDPARPLANEJA = '1' AND (EXISTS (SELECT 1 FROM LISTA WHERE NRLISTA = :NRLISTA AND PARAMPLANEJA.CDFILIAL = CDLISTA) OR :ALLCDFILIAL = 'T')";
        
        $params = array(
            "TXMENSCARSEM"  => $rowParamPlaneja[0]['TXMENSCARSEM'],
            "ALLCDFILIAL"   => $allCdFilial,
            "NRLISTA"       => $nrlista
        );
        self::executeQuery($sql, $params);
    }
    
    public function exportMensCardMens($request, $response, $nrlista, $rowParamPlaneja, $allCdFilial){
        $sql = "UPDATE PARAMPLANEJA SET TXMENSCARMES = :TXMENSCARMES WHERE CDPARPLANEJA = '1' AND (EXISTS (SELECT 1 FROM LISTA WHERE NRLISTA = :NRLISTA AND PARAMPLANEJA.CDFILIAL = CDLISTA) OR :ALLCDFILIAL = 'T')";
        
        $params = array(
            "TXMENSCARMES"  => $rowParamPlaneja[0]['TXMENSCARMES'],
            "ALLCDFILIAL"   => $allCdFilial,
            "NRLISTA"       => $nrlista
        );
        
        self::executeQuery($sql, $params);
    }
    
    public function exportReqRetPrato($request, $response, $nrlista, $rowParamPlaneja, $allCdFilial){
        $sql    = "UPDATE PARAMPLANEJA SET IDUTREQUPRAT = :IDUTREQUPRAT, IDRATEIORETGER = :IDRATEIORETGER, IDEXIBESALDOESTRETI = :IDEXIBESALDOESTRETI WHERE CDPARPLANEJA = '1' AND (EXISTS (SELECT 1 FROM LISTA WHERE NRLISTA = :NRLISTA AND PARAMPLANEJA.CDFILIAL = CDLISTA) OR :ALLCDFILIAL = 'T')";
        
        $params = array(
            "IDUTREQUPRAT"          => $rowParamPlaneja[0]['IDUTREQUPRAT'],
            "IDRATEIORETGER"        => $rowParamPlaneja[0]['IDRATEIORETGER'],
            "IDEXIBESALDOESTRETI"   => $rowParamPlaneja[0]['IDEXIBESALDOESTRETI'],
            "ALLCDFILIAL"           => $allCdFilial,
            "NRLISTA"               => $nrlista
        );
        
        self::executeQuery($sql, $params);
    }
    
    public function exportConfigPrato($request, $response, $nrlista, $rowParamPlaneja, $allCdFilial){
        $sql    = "UPDATE PARAMPLANEJA SET IDQTLIQUBRUT = :IDQTLIQUBRUT, IDBLOALTRELO = :IDBLOALTRELO WHERE CDPARPLANEJA = '1' AND (EXISTS (SELECT 1 FROM LISTA WHERE NRLISTA = :NRLISTA AND PARAMPLANEJA.CDFILIAL = CDLISTA) OR :ALLCDFILIAL = 'T')";
        
        $params = array(
            "IDQTLIQUBRUT"  => $rowParamPlaneja[0]['IDQTLIQUBRUT'],
            "IDBLOALTRELO"  => $rowParamPlaneja[0]['IDBLOALTRELO'],
             "ALLCDFILIAL"  => $allCdFilial,
             "NRLISTA"      => $nrlista
        );
        
        self::executeQuery($sql, $params);
    }
    
    public function exportDadosTransporte($request, $response, $nrlista, $rowParamPlaneja, $rowUnidMediFili, $allCdFilial){
        $sql    = "UPDATE PARAMPLANEJA SET VRPEMINCONT = :VRPEMINCONT WHERE CDPARPLANEJA = '1' AND (EXISTS (SELECT 1 FROM LISTA WHERE NRLISTA = :NRLISTA AND PARAMPLANEJA.CDFILIAL = CDLISTA) OR :ALLCDFILIAL = 'T')";
        $params = array(
            "VRPEMINCONT"   => $rowParamPlaneja[0]['VRPEMINCONT'], 
            "ALLCDFILIAL"   => $allCdFilial,
            "NRLISTA"       => $nrlista
        );
        self::executeQuery($sql, $params);
        
        self::updateUniMedFili($rowUnidMediFili, $nrlista);
    }
    
    public function exportCalcConsPla($request, $response, $nrlista, $filialOrigem, $allCdFilial, $rowParamFilial){
        $sql    = "UPDATE PARAMFILIAL SET VRPERCENTACRES = :VRPERCENTACRES WHERE (EXISTS (SELECT 1 FROM LISTA WHERE NRLISTA = :NRLISTA AND PARAMFILIAL.CDFILIAL = CDLISTA) OR :ALLCDFILIAL = 'T')";
        $params = array(
            "VRPERCENTACRES"=> $rowParamFilial[0]['VRPERCENTACRES'],
            "ALLCDFILIAL"   => $allCdFilial,
            "NRLISTA"       => $nrlista
        );
        self::executeQuery($sql, $params);
        
    }
    
    public function exportElabCard($request, $response, $nrlista, $rowParamPlaneja, $allCdFilial){
        $sql    = "UPDATE PARAMPLANEJA SET IDPERCCOME = :IDPERCCOME, CDTIPOCUSTOPLA = :CDTIPOCUSTOPLA, CDTIPOCUSTOREA = :CDTIPOCUSTOREA, IDEXIBECUSTO = :IDEXIBECUSTO WHERE CDPARPLANEJA = '1' AND (EXISTS (SELECT 1 FROM LISTA WHERE NRLISTA = :NRLISTA AND PARAMPLANEJA.CDFILIAL = CDLISTA) OR :ALLCDFILIAL = 'T')";
        
        $params = array(
            "IDPERCCOME"        => $rowParamPlaneja[0]['IDPERCCOME'],
            "CDTIPOCUSTOPLA"    => $rowParamPlaneja[0]['CDTIPOCUSTOPLA'],
            "CDTIPOCUSTOREA"    => $rowParamPlaneja[0]['CDTIPOCUSTOREA'],
            "IDEXIBECUSTO"      => $rowParamPlaneja[0]['IDEXIBECUSTO'],
            "ALLCDFILIAL"       => $allCdFilial,
            "NRLISTA"           => $nrlista
        );
        self::executeQuery($sql, $params);
    }
    
    public function exportProdDist($request, $response, $nrlista, $rowParamPlaneja, $allCdFilial){
        $sql    = "UPDATE PARAMPLANEJA SET CDTPDISTRSAID = :CDTPDISTRSAID, CDTPDISTRENTR = :CDTPDISTRENTR, QTDIAVALPRODA = :QTDIAVALPRODA, QTVALIDPRODCONG = :QTVALIDPRODCONG, QTVALIDPRODRESF = :QTVALIDPRODRESF WHERE CDPARPLANEJA = '1' AND (EXISTS (SELECT 1 FROM LISTA WHERE NRLISTA = :NRLISTA AND PARAMPLANEJA.CDFILIAL = CDLISTA) OR :ALLCDFILIAL = 'T')";
        
        $params = array(
            "CDTPDISTRSAID"      => $rowParamPlaneja[0]['CDTPDISTRSAID'],
            "CDTPDISTRENTR"      => $rowParamPlaneja[0]['CDTPDISTRENTR'],
            "QTDIAVALPRODA"      => $rowParamPlaneja[0]['QTDIAVALPRODA'],
            "QTVALIDPRODCONG"    => $rowParamPlaneja[0]['QTVALIDPRODCONG'],
            "QTVALIDPRODRESF"    => $rowParamPlaneja[0]['QTVALIDPRODRESF'],
            "ALLCDFILIAL"        => $allCdFilial,
            "NRLISTA"            => $nrlista
        );
        
        self::executeQuery($sql, $params);
        
    }
    
    public function getParamsParamPlaneja($filialOrigem){
            $sql = "SELECT NRORG, CDNUTRRELAT1, CDNUTRRELAT2, CDNUTRRELAT3, CDNUTRRELAT4, IDBLPRCUSZER, IDCARDIAUTIL, IDCUSPADCAR, IDRESTRCARD, IDRESTRAPROVCARD, IDACOMPCUSTO, IDCONSGRPRAT, IDSOMACOMEST, IDCALPADCMP, IDCARDIFRETI, VRINDCALCMP, CDTPRETIPADR, CDTPCUSTCMP, IDPRINVENRETI, IDBLOQNECCOMP, IDSERVINCFILAGR, IDENVMAILCARD, IDCONSPROD, IDPERCCOME, NRCORSAFRA, NRCORINICSAF, NRCORENTRSAF, NRCORNUTIL, NRCORNALTE, NRCORCARDESP, NRCORCARDREV, IDALTCOMCARD, VRPEMAXDIFPLAPA, VRPEMINDIFPLAPA, CDTIPOCUSTODESC, IDBLQFECHCARD, TXLAYOUTCATR, IDEFETCARDIA, IDPEREFEPOSDTPR, IDPERLEFESRETPLA, IDBLQEFEDIAFECH, NRDIAANTDTPROC, IDPEREFETFATMPLA, TXMENSCARDIA, TXMENSCARSEM, TXMENSCARMES, IDUTREQUPRAT, CDTCACONSPER, CDTPRCONSFIX, CDPRACONSFIX, CDTCACONSFIX, CDFILCONSPER, CDTPRCONSPER, CDPRACONSPER, IDRATEIORETGER, IDEXIBESALDOESTRETI, IDQTLIQUBRUT, IDBLOALTRELO, VRPEMINCONT, IDPERCCOME, CDTIPOCUSTOPLA, CDTIPOCUSTOREA, IDEXIBECUSTO, CDTPDISTRSAID, CDTPDISTRENTR, QTDIAVALPRODA, QTVALIDPRODCONG, QTVALIDPRODRESF, IDUTLVALCARD, IDBLOQREQVALCARD, IDBLOQLIBCAVALCARD, IDBLOQAPRCAVALCARD, IDBLOQAPMATVALCARD, IDBLOQPREVCONVALCARD FROM PARAMPLANEJA WHERE CDFILIAL = :CDFILIAL AND CDPARPLANEJA = '1'";
            
            $params = array(
                "CDFILIAL" => $filialOrigem
            );
            
            $query  = $this->entityManager->getConnection()->prepare($sql);
            $query->execute($params);
            $result = $query->fetchAll();
            return $result;
    }
    
    public function getParamsParamFilial($filialOrigem){
        
            $sql = "SELECT IDUTRETBASEINVE, IDCOMCUSPERC, VRPERCENTACRES FROM PARAMFILIAL WHERE CDFILIAL = :CDFILIAL";
            $params = array(
                "CDFILIAL" => $filialOrigem
            );
            
            $query  = $this->entityManager->getConnection()->prepare($sql);
            $query->execute($params);
            $result = $query->fetchAll();
            return $result;
    }
    
    public function getParamsUnidMediFili($filialOrigem){
            $sql = "SELECT SGUNIDADE, QTAMOSTRAUN FROM UNIDMEDIFILI WHERE CDFILIAL = :CDFILIAL";
            $params = array(
                "CDFILIAL" => $filialOrigem
            );
            
            $query  = $this->entityManager->getConnection()->prepare($sql);
            $query->execute($params);
            $result = $query->fetchAll();
            return $result;
    }
    
    public function verifyExistParamPlanejaExport($nrlista){
        // $filial = explode('_', $filialDestino);
        $sql = "SELECT CDLISTA FROM LISTA WHERE NRLISTA = :NRLISTA";
        $params = array(
            "NRLISTA"   =>  $nrlista
        );
        $query  = $this->connection->prepare($sql);
        $query->execute($params);
        $filiais = $query->fetchAll();
        foreach ($filiais as $key => &$fili){
            $sql    = "SELECT CDPARPLANEJA FROM PARAMPLANEJA WHERE CDFILIAL = :CDFILIAL";
            $params = array(
                "CDFILIAL" => $fili['CDLISTA']
            );
            $query  = $this->connection->prepare($sql);
            $query->execute($params);
            $result = $query->fetchAll();
            if (empty($result)) {
                self::insertParamPlaneja($fili['CDLISTA']);
            }
        }
    }
    
    public function verifyExistParamPlaneja($row){
        $sql    = "SELECT CDPARPLANEJA FROM PARAMPLANEJA WHERE CDFILIAL = :CDFILIAL";
        $params = array(
            "CDFILIAL" => $row['CDFILIAL']
        );
        $query  = $this->connection->prepare($sql);
        $query->execute($params);
        $result = $query->fetchAll();
        if (empty($result)) {
            self::insertParamPlaneja($row['CDFILIAL']);
        }
        
    }
    
     public function insertParamPlaneja($filialDestino){
        $sql    = "INSERT INTO PARAMPLANEJA (CDFILIAL, CDPARPLANEJA, IDPRINVENRETI, IDALTCOMCARD, IDBLOQNECCOMP, IDENVMAILCARD, IDRATEIORETGER) VALUES (:CDFILIAL, '1', 'N', 'N', 'N', 'N', '1')";
        $params = array(
            "CDFILIAL" => $filialDestino
        );
        self::executeQuery($sql, $params);
    }
    
    public function updateUniMedFili($rowsGrid, $nrlista){
        $sql = "SELECT CDLISTA FROM LISTA WHERE NRLISTA = :NRLISTA";
        $params = array(
            "NRLISTA"   =>  $nrlista
        );
        $query  = $this->connection->prepare($sql);
        $query->execute($params);
        $filiais = $query->fetchAll();
        foreach ($filiais as $key => &$fili){
            foreach($rowsGrid as $key => &$row){
                $sql = "SELECT * FROM UNIDMEDIFILI WHERE SGUNIDADE = :SGUNIDADE AND CDFILIAL = :CDFILIAL";
                $params = array("SGUNIDADE" => $row['SGUNIDADE'],
                                "CDFILIAL" => $fili['CDLISTA']);
            
                            
    	        $query = $this->connection->prepare($sql);
                $query->execute($params);
                $rows = $query->fetchAll();
                if(empty($rows)){
                    self::insertUnidMediFili($fili['CDLISTA'], $row['SGUNIDADE'], $row['QTAMOSTRAUN']);
                }else{
                    self::updateUnidMediFili($fili['CDLISTA'], $row['SGUNIDADE'], $row['QTAMOSTRAUN']);
                }
            }
        }
    }
    
     public function insertUnidMediFili($filialDestino, $sgunidade, $qtamostraun){
        $sql    = "INSERT INTO UNIDMEDIFILI (CDFILIAL, SGUNIDADE, QTAMOSTRAUN) VALUES (:CDFILIAL , :SGUNIDADE, :QTAMOSTRAUN)";
        $params = array(
            "CDFILIAL"    => $filialDestino,
            "SGUNIDADE"   => $sgunidade,
            "QTAMOSTRAUN" => $qtamostraun
        );
        
        self::executeQuery($sql, $params);
    }
    
     public function updateUnidMediFili($filialDestino, $sgunidade, $qtamostraun){
        $sql    = "UPDATE UNIDMEDIFILI SET QTAMOSTRAUN = :QTAMOSTRAUN WHERE CDFILIAL = :CDFILIAL AND SGUNIDADE= :SGUNIDADE";
        $params = array(
            "CDFILIAL"    => $filialDestino,
            "SGUNIDADE"   => $sgunidade,
            "QTAMOSTRAUN" => $qtamostraun
        );
        self::executeQuery($sql, $params);
    }
    
    public function insertMessage($row){
        $sql    = "INSERT INTO MENSAPROVCARD (QTDIAMENS, DSMENSAPROVCARD) Values(-1, :DSMENSAPROVCARD)";
        $params = array(
            "DSMENSAPROVCARD"    => $row['DSMENSAPROVCARD']
        );
        self::executeQuery($sql, $params);
    }
    
    public function updateMessage($row){
        $sql    = "UPDATE MENSAPROVCARD SET DSMENSAPROVCARD = :DSMENSAPROVCARD WHERE QTDIAMENS = -1";
        $params = array(
            "DSMENSAPROVCARD"    => $row['DSMENSAPROVCARD']
        );
        self::executeQuery($sql, $params);
    }
    
    public function executeQuery($sql, $params){
        $query = $this->connection->prepare($sql);
        $query->execute($params);
    }
}